#include <caml/mlvalues.h>
#include <caml/memory.h>
#include <gtk/gtk.h>

#define GtkObject_ml(object) (GTK_OBJECT(object))
#define GtkWidget_ml(object) (GTK_WIDGET(object))
#define GtkBox_ml(object) (GTK_BOX(object))
#define GtkList_ml(object) (GTK_LIST(object))
#define GtkMenu_ml(object) (GTK_MENU(object))
#define GtkMenuItem_ml(object) (GTK_MENU_ITEM(object))
#define GtkMenuBar_ml(object) (GTK_MENU_BAR(object))
#define GtkContainer_ml(object) (GTK_CONTAINER(object))
#define GtkPaned_ml(object) (GTK_PANED(object))
#define GtkTooltips_ml(object) (GTK_TOOLTIPS(object))
#define GtkWindow_ml(object) (GTK_WINDOW(object))
#define GtkButton_ml(object) (GTK_BUTTON(object))
#define GtkToggleButton_ml(object) (GTK_TOGGLE_BUTTON(object))
#define GtkProgressBar_ml(object) (GTK_PROGRESS_BAR(object))
#define GtkText_ml(object) (GTK_TEXT(object))
#define GtkDrawingArea_ml(object) (GTK_DRAWING_AREA(object))
#define GtkColorSelection_ml(object) (GTK_COLOR_SELECTION(object))
#define GtkNotebook_ml(object) (GTK_NOTEBOOK(object))
#define GtkEditable_ml(object) (GTK_EDITABLE(object))
#define GtkEntry_ml(object) (GTK_ENTRY(object))
#define GtkFrame_ml(object) (GTK_FRAME(object))
#define GtkCheckMenuItem_ml(object) (GTK_CHECK_MENU_ITEM(object))
#define ml_GtkObject(object) ((value) object)

#define check_GtkObject_ml(object, func_id)
/* if (GtkObject_ml(object) == NULL) \
    invalid_argument(func_id) */

#define optionptr_ml(x) (Is_long(x) ? NULL : (void*) Field(x, 0))

value mlgtk_window_of(value widget)
{
  return (value) (((GtkWidget*) widget)->window);
}

value mlgtk_style_of(value widget)
{
  value r=alloc_tuple(1);
  GtkStyle *style=((GtkWidget*)widget)->style;
  int i=0;
  Field(r, i++) = (value) (style->font);
  Field(r, i++) = (value) (style->black_gc);
  Field(r, i++) = (value) (style->colormap);
  return r;
}

value mlgtk_int_poke(value ptr, value val)
{
  *((gint*) ptr) = Int_val(val);
  return Val_unit;
}

value mlgtk_int_peek(value ptr)
{
  return Val_int(*((gint*) ptr));
}

void mlgtk_callback_exec(GtkObject *object, value *closurep,
  int n_args, GtkArg *args)
{
  int i;
  value retval, car, cdr;

  /*fprintf(stderr, "callback with %d args\n", n_args);*/
  Begin_roots1(retval);
  retval=Val_int(0);
  for (i=n_args-1; i>=0; i--)
    {
      fprintf(stderr, "arg #%d type=%d\n", i,
        GTK_FUNDAMENTAL_TYPE(args[i].type));
      switch (GTK_FUNDAMENTAL_TYPE(args[i].type))
	{
	case GTK_TYPE_NONE:
	  car = Val_int(0);
	  break;

	case GTK_TYPE_INVALID:
	  car = Val_int(2);
	  break;

	case GTK_TYPE_INT:
	case GTK_TYPE_UINT:
	  car = alloc(1, 2); /* Int */
	  Field(car, 0) = Val_int(args[i].d.int_data);
	  break;

	case GTK_TYPE_LONG:
	case GTK_TYPE_ULONG:
	  car = alloc(1, 2); /* Int */
	  Field(car, 0) = Val_int(args[i].d.long_data);
	  break;

	case GTK_TYPE_BOOL:
	  car = alloc(1, 0); /* Bool */
	  Field(car, 0) = Val_int(args[i].d.int_data);
	  break;

	case GTK_TYPE_CHAR:
	  car = alloc(1, 1); /* Char */
	  Field(car, 0) = Val_int(args[i].d.char_data);
	  break;

	case GTK_TYPE_FLOAT:
	  car = alloc(1, 3); /* Float */
	  Field(car, 0) = copy_double(args[i].d.float_data);
	  break;

	case GTK_TYPE_STRING:
	  car = alloc(1, 4); /* Float */
	  Field(car, 0) = copy_string(args[i].d.string_data);
	  break;

	case GTK_TYPE_POINTER:
	case GTK_TYPE_BOXED:
	  car = alloc(1, 5); /* Pointer */
	  Field(car, 0) = (value) args[i].d.pointer_data;
	  break;

	default: car = Val_int(1); /* Other */
	}
      cdr=retval;
      retval = alloc(2, 0);
      Field(retval, 0)=car;
      Field(retval, 1)=cdr;
    }
  fflush(stderr);

  retval = callback(*closurep, retval);
  End_roots();

  if (Is_long(retval))
    {
      switch (Int_val(retval))
	{
	case 0: /* unit */
	  switch (GTK_FUNDAMENTAL_TYPE(args[n_args].type))
	    {
	    case GTK_TYPE_NONE:
	      return;
	    }
	}
    }
  else
    {
      switch (Tag_val(retval))
	{
	case 0: /* bool */
	  switch (GTK_FUNDAMENTAL_TYPE(args[n_args].type))
	    {
	    case GTK_TYPE_BOOL:
	      *((gint*) (args[n_args].d.pointer_data)) = Int_val(Field(retval, 0));
	      return;
	    }

	case 1: /* char */
	  switch (GTK_FUNDAMENTAL_TYPE(args[n_args].type))
	    {
	    case GTK_TYPE_CHAR:
	      *((gchar*) (args[n_args].d.pointer_data)) = Int_val(Field(retval, 0));
	      return;
	    }

	case 2: /* int */
	  switch (GTK_FUNDAMENTAL_TYPE(args[n_args].type))
	    {
	    case GTK_TYPE_ENUM:
	    case GTK_TYPE_INT:
	    case GTK_TYPE_UINT:
	      *((gint*) (args[n_args].d.pointer_data)) = Int_val(Field(retval, 0));
	      return;

	    case GTK_TYPE_LONG:
	    case GTK_TYPE_ULONG:
	      *((glong*) (args[n_args].d.pointer_data)) = Int_val(Field(retval, 0));
	      return;
	    }

	case 3: /* float */
	  switch (GTK_FUNDAMENTAL_TYPE(args[n_args].type))
	    {
	    case GTK_TYPE_FLOAT:
	      *((gfloat*) (args[n_args].d.pointer_data)) = Double_val(Field(retval, 0));
	      return;
	    }

	case 4: /* string */
	  switch (GTK_FUNDAMENTAL_TYPE(args[n_args].type))
	    {
	    case GTK_TYPE_STRING:
	      *((gchar**) (args[n_args].d.pointer_data)) = String_val(Field(retval, 0));
	      return;
	    }	  
	}
    }
  fprintf(stderr, "Gtk callbacks, typecheck error in return value, wanted=%d\n",
    GTK_FUNDAMENTAL_TYPE(args[n_args].type));
  failwith("Gtk.__callback_handler__");
}

void mlgtk_callback_destroy(value *closurep)
{
    free(closurep);
}

/************************
EVENT (DE)CONNECTION
************************/

value mlgtk_signal_connect(value object, value name, value func)
{
  value *cbk;
  check_GtkObject_ml(object, "Gtk.Unsafe.signal_connect");
  cbk = (value*) malloc(sizeof(value));
  register_global_root(cbk);
  *cbk = func;
  return Val_int(gtk_signal_connect_interp(
    GtkObject_ml(object), String_val(name),
    (GtkCallbackMarshal) mlgtk_callback_exec, cbk,
    (GtkDestroyNotify) mlgtk_callback_destroy, 1));
}

value mlgtk_signal_disconnect(value object, value index)
{
  gtk_signal_disconnect(GtkObject_ml(object), Int_val(index));
}

/************************
OBJECT CREATION FUNCTIONS
************************/

value mlgtk_window_new(value window_type)
{
  return ml_GtkObject(gtk_window_new(Int_val(window_type)));
}

value mlgtk_button_new_with_label(value label)
{
  return ml_GtkObject(gtk_button_new_with_label(String_val(label)));
}

value mlgtk_check_button_new_with_label(value label)
{
  return ml_GtkObject(gtk_check_button_new_with_label(String_val(label)));
}

value mlgtk_toggle_button_new_with_label(value label)
{
  return ml_GtkObject(gtk_toggle_button_new_with_label(String_val(label)));
}

value mlgtk_radio_button_new_with_label(value group, value label)
{
  return ml_GtkObject(gtk_radio_button_new_with_label(
    optionptr_ml(group), String_val(label)));
}

value mlgtk_hbox_new(value homogeneous, value spacing)
{
  return ml_GtkObject(gtk_hbox_new(Int_val(homogeneous), Int_val(spacing)));
}

value mlgtk_vbox_new(value homogeneous, value spacing)
{
  return ml_GtkObject(gtk_vbox_new(Int_val(homogeneous), Int_val(spacing)));
}

value mlgtk_label_new(value str)
{
  return ml_GtkObject(gtk_label_new(String_val(str)));
}

value mlgtk_hseparator_new(value dummy)
{
  return ml_GtkObject(gtk_hseparator_new ());
}

value mlgtk_vseparator_new(value dummy)
{
  return ml_GtkObject(gtk_vseparator_new ());
}

value mlgtk_progress_bar_new(value dummy)
{
  return ml_GtkObject(gtk_progress_bar_new ());
}

value mlgtk_tooltips_new(value dummy)
{
  return ml_GtkObject(gtk_tooltips_new ());
}

value mlgtk_list_item_new_with_label(value s)
{
  return ml_GtkObject(gtk_list_item_new_with_label(String_val(s)));
}

value mlgtk_list_new(value dummy)
{
  return ml_GtkObject(gtk_list_new());
}

value mlgtk_menu_new(value dummy)
{
  return ml_GtkObject(gtk_menu_new());
}

value mlgtk_menu_bar_new(value dummy)
{
  return ml_GtkObject(gtk_menu_bar_new());
}

value mlgtk_menu_item_new_with_label(value str)
{
  return ml_GtkObject(gtk_menu_item_new_with_label(String_val(str)));
}

value mlgtk_check_menu_item_new_with_label(value str)
{
  return ml_GtkObject(gtk_check_menu_item_new_with_label(String_val(str)));
}

value mlgtk_check_menu_item_new(value dummy)
{
  return ml_GtkObject(gtk_check_menu_item_new());
}

value mlgtk_check_menu_item_set_state(value object,value state)
{
  check_GtkObject_ml(object, "Gtk.Unsafe.check_menu_item_set_state");
  gtk_check_menu_item_set_state(GtkCheckMenuItem_ml(object),Int_val(state));
  return Val_unit;
}

value mlgtk_radio_menu_item_new_with_label(value group, value label)
{
  return ml_GtkObject(gtk_radio_menu_item_new_with_label(
    optionptr_ml(group), String_val(label)));
}

value mlgtk_object_destroy(value object)
{
  struct callback *cbk, *nxt;
  check_GtkObject_ml(object, "Gtk.Unsafe.object_destroy");
  gtk_signal_handlers_destroy(GtkObject_ml(object));
  gtk_object_destroy(GtkObject_ml(object));
  /*GtkObject_ml(object) = NULL;*/
  return Val_unit;
}

value mlgtk_text_new(value dummy)
{
  GtkWidget* text;
  text = gtk_text_new (NULL,NULL); /* pcuoq : NULL at least until GtkAdjustment 
				      is documented */
  return ml_GtkObject(text);
}

value mlgtk_widget_realize(value mlwidget)
{
  check_GtkObject_ml(mlwidget, "Gtk.Unsafe.widget_realize");
  gtk_widget_realize(GtkWidget_ml(mlwidget));
  return Val_unit;
}

value mlgtk_widget_unrealize(value mlwidget)
{
  check_GtkObject_ml(mlwidget, "Gtk.Unsafe.widget_unrealize");
  gtk_widget_unrealize(GtkWidget_ml(mlwidget));
  return Val_unit;
}

value mlgtk_vpaned_new(value dummy)
{
  return ml_GtkObject(gtk_vpaned_new());
}

value mlgtk_hpaned_new(value dummy)
{
  return ml_GtkObject(gtk_hpaned_new());
}

value mlgtk_notebook_new(value dummy)
{
  return ml_GtkObject(gtk_notebook_new());
}

value mlgtk_entry_new(value dummy)
{
  return ml_GtkObject(gtk_entry_new());
}

value mlgtk_entry_new_with_max_length(value len)
{
  return ml_GtkObject( gtk_entry_new_with_max_length((guint16) Int_val(len)) ) ;
}


/************************
CONTAINERS
************************/


value mlgtk_frame_new(value label)
{
  return ml_GtkObject(gtk_frame_new(String_val(label)));
}

value mlgtk_frame_set_shadow_type(value frame,value type)
{
  check_GtkObject_ml(frame, "Gtk.Unsafe.frame_set_shadow_type");
  check_GtkObject_ml(type, "Gtk.Unsafe.frame_set_shadow_type");
  gtk_frame_set_shadow_type(GtkFrame_ml(frame),Int_val(type));
}

value mlgtk_scrolled_window_new (value dummy)
{
  return ml_GtkObject(gtk_scrolled_window_new (NULL, NULL));
  /* FIXME : should take 2 arguments GtkAdjustment */
}

value mlgtk_paned_add1(value ml_paned,value ml_widget)
{
  check_GtkObject_ml(ml_paned, "Gtk.Unsafe.paned_add1");
  check_GtkObject_ml(ml_widget, "Gtk.Unsafe.paned_add1");
  gtk_paned_add1(GtkPaned_ml(ml_paned),GtkWidget_ml(ml_widget));
}


value mlgtk_paned_add2(value ml_paned,value ml_widget)
{
  check_GtkObject_ml(ml_paned, "Gtk.Unsafe.paned_add2");
  check_GtkObject_ml(ml_widget, "Gtk.Unsafe.paned_add2");
  gtk_paned_add2(GtkPaned_ml(ml_paned),GtkWidget_ml(ml_widget));
}

value mlgtk_container_add(value container, value widget)
{
  check_GtkObject_ml(container, "Gtk.Unsafe.container_add");
  check_GtkObject_ml(widget, "Gtk.Unsafe.container_add");
  gtk_container_add(
    GtkContainer_ml(container), GtkWidget_ml(widget));
  return Val_unit;
}

value mlgtk_container_border_width(value window, value width)
{
  gtk_container_border_width(GTK_CONTAINER(window), Int_val(width));
  return Val_unit;
}

value mlgtk_box_pack_start(value container, value widget,
  value expand, value fill, value padding)
{
  check_GtkObject_ml(container, "Gtk.Unsafe.container_add");
  check_GtkObject_ml(widget, "Gtk.Unsafe.container_add");
  gtk_box_pack_start(
    GtkBox_ml(container), GtkWidget_ml(widget),
    Int_val(expand), Int_val(fill), Int_val(padding));
  return Val_unit;  
}

value mlgtk_box_pack_end(value container, value widget,
  value expand, value fill, value padding)
{
  check_GtkObject_ml(container, "Gtk.Unsafe.container_add");
  check_GtkObject_ml(widget, "Gtk.Unsafe.container_add");
  gtk_box_pack_end(
    GtkBox_ml(container), GtkWidget_ml(widget),
    Int_val(expand), Int_val(fill), Int_val(padding));
  return Val_unit;  
}

value mlgtk_list_insert_items(value list, value items, value index)
{
  gtk_list_insert_items(GtkList_ml(list), (GList*) items, Int_val(index));
  return Val_unit;
}

value mlgtk_list_append_items(value list, value items)
{
  gtk_list_append_items(GtkList_ml(list), (GList*) items);
  return Val_unit;
}

value mlgtk_menu_item_set_submenu(value obj1, value obj2)
{
  gtk_menu_item_set_submenu(GtkMenuItem_ml(obj1), GtkWidget_ml(obj2));
  return Val_unit;
}

value mlgtk_menu_append(value obj1, value obj2)
{
  gtk_menu_append(GtkMenu_ml(obj1), GtkWidget_ml(obj2));
  return Val_unit;
}

value mlgtk_menu_bar_append(value obj1, value obj2)
{
  gtk_menu_bar_append(GtkMenuBar_ml(obj1), GtkWidget_ml(obj2));
  return Val_unit;
}

value mlgtk_tooltips_set_tip (value tooltips, value widget, value str,value private)
{
  check_GtkObject_ml(tooltips, "Gtk.Unsafe.tooltips_set_tip");
  check_GtkObject_ml(widget, "Gtk.Unsafe.tooltips_set_tip");
  gtk_tooltips_set_tip (GtkTooltips_ml(tooltips),
    GtkWidget_ml(widget), String_val(str), String_val(private));
  return Val_unit;
}

/************************
ACTIONS
************************/
value mlgtk_window_set_title(value window, value title)
{
  check_GtkObject_ml(window, "Gtk.Unsafe.window_set_title");
  gtk_window_set_title(GtkWindow_ml(window), String_val(title));
  return Val_unit;
}

value mlgtk_widget_set_usize (value widget, value x, value y)
{
  check_GtkObject_ml(widget, "Gtk.Unsafe.widget_set_usize");
  gtk_widget_set_usize(GtkWidget_ml(widget),Int_val(x),Int_val(y));
}

value mlgtk_widget_show(value widget)
{
  check_GtkObject_ml(widget, "Gtk.Unsafe.widget_show");
  gtk_widget_show(GtkWidget_ml(widget));
  return Val_unit;
}

value mlgtk_widget_hide(value widget)
{
  check_GtkObject_ml(widget, "Gtk.Unsafe.widget_hide");
  gtk_widget_hide(GtkWidget_ml(widget));
  return Val_unit;
}

value mlgtk_toggle_button_set_state(value button, value state)
{
  check_GtkObject_ml(widget, "Gtk.Unsafe.toggle_button_set_state");  
  gtk_toggle_button_set_state(GtkToggleButton_ml(button), Int_val(state));
  return Val_unit;
}

value mlgtk_progress_bar_update(value pbar, value ratio)
{
  gtk_progress_bar_update(GtkProgressBar_ml(pbar), (gfloat) Double_val(ratio));
  return Val_unit;
}

value mlgtk_timeout_add(value delay, value func)
{
  value *cbk;
  cbk = (value*) malloc(sizeof(value));
  register_global_root(cbk);
  *cbk = func;
  return Val_int(gtk_timeout_add_interp(Int_val(delay),
    (GtkCallbackMarshal) mlgtk_callback_exec, cbk,
    (GtkDestroyNotify) mlgtk_callback_destroy));
}

value mlgtk_timeout_remove(value index)
{
  gtk_timeout_remove(Int_val(index));
  return Val_unit;
}

value mlgtk_main_quit(value dummy)
{
  gtk_main_quit();
  return Val_unit;
}

int main(int argc, char **argv)
{
 gtk_set_locale ();
 
  gtk_init(&argc, &argv);
  caml_main(argv);
  /*mlgdk_init();*/
  gtk_main();
  return 0;
}

value mlgtk_notebook_append_page(value notebook,value page,value label)
{
  check_GtkObject_ml(notebook, "Gtk.Unsafe.notebook_append_page");
  check_GtkObject_ml(page, "Gtk.Unsafe.notebook_append_page");
  check_GtkObject_ml(label, "Gtk.Unsafe.notebook_append_page");
  gtk_notebook_append_page(GtkNotebook_ml(notebook),GtkWidget_ml(page),
			   GtkWidget_ml(label));
  return Val_unit;
}

value mlgtk_notebook_prepend_page(value notebook,value page,value label)
{
  check_GtkObject_ml(notebook, "Gtk.Unsafe.notebook_prepend_page");
  check_GtkObject_ml(page, "Gtk.Unsafe.notebook_prepend_page");
  check_GtkObject_ml(label, "Gtk.Unsafe.notebook_prepend_page");
  gtk_notebook_prepend_page(GtkNotebook_ml(notebook),GtkWidget_ml(page),
			   GtkWidget_ml(label));
  return Val_unit;
}

value mlgtk_notebook_set_tab_pos(value notebook,value pos)
{
  check_GtkObject_ml(notebook, "Gtk.Unsafe.notebook_set_tab_pos");
  gtk_notebook_set_tab_pos(GtkNotebook_ml(notebook), Int_val(pos));
  return Val_unit;
}

/* Function: void gtk_text_insert (GtkText *TEXT, GdkFont *FONT,
           GdkColor *FORE, GdkColor *BACK, char *CHARS, gint LENGTH) */
value mlgtk_text_insert(value ml_text, value ml_font, value ml_chars)
{
  check_GtkObject_ml(ml_text, "Gtk.Unsafe.text_insert");
  gtk_text_insert(GtkText_ml(ml_text),optionptr_ml(ml_font),NULL,NULL,
		  String_val(ml_chars), -1);
  return Val_unit;
}

value 
mlgtk_editable_insert_text(value editable,value text,value length,value position)
{
  gint gposition;
  check_GtkObject_ml(editable, "Gtk.Unsafe.editable_insert_text");
  gposition=Int_val(position);
  gtk_editable_insert_text( GtkEditable_ml(editable), String_val(text),
			     Int_val(length), &gposition );
  return Val_int(gposition);
}

value mlgtk_editable_select_region(value editable,value start,value end)
{
  check_GtkObject_ml(editable, "Gtk.Unsafe.editable_select_region"); 
  gtk_editable_select_region( GtkEditable_ml(editable), Int_val(start), Int_val(end) );
  return Val_unit;
}

value mlgtk_editable_get_chars(value editable,value start,value end)
{
  check_GtkObject_ml(editable, "Gtk.Unsafe.editable_get_chars"); 
  return copy_string( gtk_editable_get_chars( GtkEditable_ml(editable), Int_val(start), Int_val(end) ) );
}

value mlgtk_entry_get_text(value entry)
{
  check_GtkObject_ml(entry, "Gtk.Unsafe.entry_get_text");
  return copy_string( gtk_entry_get_text(GtkEntry_ml(entry)) );
}

value mlgtk_entry_set_text(value entry,value text)
{
  check_GtkObject_ml(entry, "Gtk.Unsafe.entry_set_text");
  gtk_entry_set_text(GtkEntry_ml(entry),String_val(text ));
  return Val_unit;
}

value mlgtk_text_set_editable(value ml_text,value flag)
{
  GtkWidget* text;
  check_GtkObject_ml(ml_text, "Gtk.Unsafe.text_set_editable");
  gtk_text_set_editable (GtkText_ml(ml_text), Bool_val(flag));
  return Val_unit;
}

value mlgtk_text_freeze(value mltext)
{
  check_GtkObject_ml(mltext, "Gtk.Unsafe.text_freeze");
  gtk_text_freeze(GtkText_ml(mltext));
  return Val_unit;
}

value mlgtk_text_thaw(value mltext)
{
  check_GtkObject_ml(mltext, "Gtk.Unsafe.text_thaw");
  gtk_text_thaw(GtkText_ml(mltext));
  return Val_unit;
}

value mlgtk_text_forward_delete(value mltext,value n)
{
  check_GtkObject_ml(mltext, "Gtk.Unsafe.text_forward_delete");
  return Val_int( gtk_text_forward_delete(GtkText_ml(mltext),Int_val(n)) ) ;
}

value mlgtk_text_backward_delete(value mltext,value n)
{
  check_GtkObject_ml(mltext, "Gtk.Unsafe.text_backward_delete");
  return Val_int( gtk_text_backward_delete(GtkText_ml(mltext),Int_val(n)) ) ;
}

value mlgtk_menu_item_select (value menu_item)
{
  check_GtkObject_ml(menu_item, "Gtk.Unsafe.item_select");
  gtk_menu_item_select(GtkMenuItem_ml(menu_item));
  return Val_unit;
}  

value mlgtk_menu_item_deselect (value menu_item)
{
  check_GtkObject_ml(menu_item, "Gtk.Unsafe.item_deselect");
  gtk_menu_item_deselect(GtkMenuItem_ml(menu_item));
  return Val_unit;
}  

value mlgtk_color_selection_set_color(value widget, value color)
{
  double color_g[4];
  check_GtkObject_ml(widget, "Gtk.Unsafe.color_selection_set_color");
  color_g[0]=Double_val(Field(color, 0));
  color_g[1]=Double_val(Field(color, 1));
  color_g[2]=Double_val(Field(color, 2));
  color_g[3]=Double_val(Field(color, 3));
  gtk_color_selection_set_color(GtkColorSelection_ml(widget), color_g);
  return Val_unit;
}

value mlgtk_color_selection_get_color(value widget)
{
  double color_g[4];
  value r;
  check_GtkObject_ml(widget, "Gtk.Unsafe.color_selection_set_color");
  color_g[3]=1.0;
  gtk_color_selection_get_color(GtkColorSelection_ml(widget), color_g);
  r=alloc_tuple(4);
  Field(r, 0)=Field(r, 1)=Field(r, 2)=Field(r, 3)=0;
  Field(r, 0)=copy_double(color_g[0]);
  Field(r, 1)=copy_double(color_g[1]);
  Field(r, 2)=copy_double(color_g[2]);
  Field(r, 3)=copy_double(color_g[3]);
  return r;
}

value mlgtk_color_selection_set_update_policy(value widget, value policy)
{
  gtk_color_selection_set_update_policy(GtkColorSelection_ml(widget),
    Int_val(policy));
  return Val_unit;
}

value mlgtk_color_selection_set_opacity(value widget, value flag)
{
  gtk_color_selection_set_opacity(GtkColorSelection_ml(widget),
    Int_val(flag));
  return Val_unit;
}

/*
The difference between the bytecode and native compilers about records
containing only float fields doesn't apply to tuples.

value mlgtk_color_selection_set_color_native(value widget, value color)
{
  double color_g[4];
  check_GtkObject_ml(widget, "Gtk.Unsafe.color_selection_set_color");
  fprintf(stderr, "val %d %d\n", Tag_val(color), Wosize_val(color));
  fflush(stderr);
  color_g[0]=Double_field(color, 0);
  color_g[1]=Double_field(color, 1);
  color_g[2]=Double_field(color, 2);
  color_g[3]=Double_field(color, 3);
  gtk_color_selection_set_color(widget, color_g);
  return Val_unit;
}

value mlgtk_color_selection_get_color_native(value widget)
{
  double color_g[4];
  value r;
  check_GtkObject_ml(widget, "Gtk.Unsafe.color_selection_set_color");
  color_g[3]=1.0;
  gtk_color_selection_get_color(widget, color_g);
  r=alloc_tuple(4 * sizeof(double) / sizeof(value));
  Store_double_field(r, 0, color_g[0]);
  Store_double_field(r, 1, color_g[1]);
  Store_double_field(r, 2, color_g[2]);
  Store_double_field(r, 3, color_g[3]);
  return r;
}
*/

gint mlgtk_convert_events(value events)
{
  gint r=0;
  while (events!= 1)
    {
      r |= 2<< (Int_val(Field(events,0)));
      events = Field(events, 1);
    }
  return r;
}

value mlgtk_widget_set_events(value widget, value events)
{
  gtk_widget_set_events(GtkWidget_ml(widget), mlgtk_convert_events(events));
  return Val_unit;
}

value mlgtk_drawing_area_size(value darea,
  gint width, gint height)
{
  gtk_drawing_area_size(GtkDrawingArea_ml(darea),
    Int_val(width), Int_val(height));
  return Val_unit;
}

